module CucumberPriority
  class Util
    class << self

      def alias_chain(mod, target, feature)
        mod.class_eval do
          # Strip out punctuation on predicates, bang or writer methods since
          # e.g. target?_without_feature is not a valid method name.
          aliased_target, punctuation = target.to_s.sub(/([?!=])$/, ''), $1
          yield(aliased_target, punctuation) if block_given?

          with_method = "#{aliased_target}_with_#{feature}#{punctuation}"
          without_method = "#{aliased_target}_without_#{feature}#{punctuation}"

          alias_method without_method, target
          alias_method target, with_method

          case
            when public_method_defined?(without_method)
              public target
            when protected_method_defined?(without_method)
              protected target
            when private_method_defined?(without_method)
              private target
          end
        end
      end
    end
  end
end
